import marshmallow as ma

from .data_type import DataTypeField, DataTypeSchema


class InvalidUser(ma.Schema):
    """
    Error details when the caller's identity does not map to valid local
    account.
    """

    _DATA_TYPE = "invalid_user#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)
    usernames = ma.fields.List(
        ma.fields.String,
        description="List of connector-specific usernames",
    )


invalid_user_schema = InvalidUser()
DataTypeSchema.register_schema(invalid_user_schema)
