import marshmallow as ma
from .data_type import DataTypeField, DataTypeSchema


class MissingRequiredScopes(ma.Schema):
    """
    Error details when a user has authenticated but lacks an OAuth scope to be
    able to perform the requested operation.
    """

    _DATA_TYPE = "missing_required_scopes#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)
    required_scopes = ma.fields.List(
        ma.fields.String, description="List of OAuth scope names"
    )


missing_required_scopes_schema = MissingRequiredScopes()
DataTypeSchema.register_schema(missing_required_scopes_schema)
