import datetime

import marshmallow as ma
from ..api.data_type import DataTypeField


class AcmeAccountSchema(ma.Schema):
    """
    Let's Encrypt Acme Account used for managing certificates for an Endpoint
    """

    _DATA_TYPE = "acme_account#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)

    acme_key = ma.fields.Raw()
    acme_account = ma.fields.Raw()
    lease_node_id = ma.fields.UUID(required=False)
    lease_expiration = ma.fields.AwareDateTime(
        required=False, default_timezone=datetime.timezone.utc
    )


acme_account_schema = AcmeAccountSchema()
